// copy-n-pasted from XProger's eXgine
unit textures;

interface

uses
  Windows, opengl;

type   TByteArray = array [0..1023] of Byte;
       PByteArray = ^TByteArray;

const
  GL_LUMINANCE8                     = $8040;
  GL_RGB8                           = $8051;
  GL_RGBA8                          = $8058;
  GL_BGR                            = $80E0;
  GL_BGRA                           = $80E1;
  GL_CLAMP_TO_EDGE                  = $812F;
  GENERATE_MIPMAP_SGIS              = $8191;

  procedure glGenTextures(n: GLsizei; textures: PGLuint); stdcall; external opengl32;
  procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;

  function Load(FileName: PChar; Clamp, MipMap: Boolean):  LongWord;

implementation

const
  IID_IPicture : TGUID = '{7BF80980-BF32-101A-8BBB-00AA00300CAB}';

type
  OLE_HANDLE = LongWord;
  OLE_XPOS_HIMETRIC  = Longint;
  OLE_YPOS_HIMETRIC  = Longint;
  OLE_XSIZE_HIMETRIC = Longint;
  OLE_YSIZE_HIMETRIC = Longint;

  PCLSID = PGUID;
  TCLSID = TGUID;

  TOleChar = WideChar;
  POleStr  = PWideChar;
  PPOleStr = ^POleStr;
  Largeint = Int64;

  TVarData = packed record
    VType     : Word;
    Reserved1 : Word;
    Reserved2 : Word;
    Reserved3 : Word;
    varOleStr : PWideChar;
    Reserved4 : Word;
    Reserved5 : Word;
  end;

  PStatStg = ^TStatStg;
  tagSTATSTG = record
    pwcsName: POleStr;
    dwType: Longint;
    cbSize: Largeint;
    mtime: TFileTime;
    ctime: TFileTime;
    atime: TFileTime;
    grfMode: Longint;
    grfLocksSupported: Longint;
    clsid: TCLSID;
    grfStateBits: Longint;
    reserved: Longint;
  end;
  TStatStg = tagSTATSTG;
  {$EXTERNALSYM STATSTG}
  STATSTG = TStatStg;

  ISequentialStream = interface(IUnknown)
    ['{0c733a30-2a1c-11ce-ade5-00aa0044773d}']
    function Read(pv: Pointer; cb: Longint; pcbRead: PLongint): HResult;
      stdcall;
    function Write(pv: Pointer; cb: Longint; pcbWritten: PLongint): HResult;
      stdcall;
  end;

  IStream = interface(ISequentialStream)
    ['{0000000C-0000-0000-C000-000000000046}']
    function Seek(dlibMove: Largeint; dwOrigin: Longint;
      out libNewPosition: Largeint): HResult; stdcall;
    function SetSize(libNewSize: Largeint): HResult; stdcall;
    function CopyTo(stm: IStream; cb: Largeint; out cbRead: Largeint;
      out cbWritten: Largeint): HResult; stdcall;
    function Commit(grfCommitFlags: Longint): HResult; stdcall;
    function Revert: HResult; stdcall;
    function LockRegion(libOffset: Largeint; cb: Largeint;
      dwLockType: Longint): HResult; stdcall;
    function UnlockRegion(libOffset: Largeint; cb: Largeint;
      dwLockType: Longint): HResult; stdcall;
    function Stat(out statstg: TStatStg; grfStatFlag: Longint): HResult;
      stdcall;
    function Clone(out stm: IStream): HResult; stdcall;
  end;

  IPicture = interface
    ['{7BF80980-BF32-101A-8BBB-00AA00300CAB}']
    function get_Handle(out handle: OLE_HANDLE): HResult;  stdcall;
    function get_hPal(out handle: OLE_HANDLE): HResult; stdcall;
    function get_Type(out typ: Smallint): HResult; stdcall;
    function get_Width(out width: OLE_XSIZE_HIMETRIC): HResult; stdcall;
    function get_Height(out height: OLE_YSIZE_HIMETRIC): HResult; stdcall;
    function Render(dc: HDC; x, y, cx, cy: Longint;
      xSrc: OLE_XPOS_HIMETRIC; ySrc: OLE_YPOS_HIMETRIC;
      cxSrc: OLE_XSIZE_HIMETRIC; cySrc: OLE_YSIZE_HIMETRIC;
      rcWBounds: Pointer): HResult; stdcall;
    function set_hPal(hpal: OLE_HANDLE): HResult; stdcall;
    function get_CurDC(out dcOut: HDC): HResult; stdcall;
    function SelectPicture(dcIn: HDC; out hdcOut: HDC;
      out bmpOut: OLE_HANDLE): HResult; stdcall;
    function get_KeepOriginalFormat(out fkeep: BOOL): HResult; stdcall;
    function put_KeepOriginalFormat(fkeep: BOOL): HResult; stdcall;
    function PictureChanged: HResult; stdcall;
    function SaveAsFile(const stream: IStream; fSaveMemCopy: BOOL;
      out cbSize: Longint): HResult; stdcall;
    function get_Attributes(out dwAttr: Longint): HResult; stdcall;
  end;

  function OleLoadPictureFile(varFileName: TVarData; var lpdispPicture:
                                 IDispatch): HResult; stdcall; external 'oleaut32.dll';
  function OleLoadPicture(stream: IStream; lSize: Longint; fRunmode: BOOL;
                                 const iid: TGUID; out vObject): HResult; stdcall; external 'olepro32.dll';
  function CreateStreamOnHGlobal(hglob: HGlobal; fDeleteOnRelease: BOOL;
                                 out stm: IStream): HResult; stdcall; external 'ole32.dll';
                                 
//   ,    OLE 
procedure CreateBitmap(pPicture: IPicture; var Width, Height, BPP: Integer; var Data: PByteArray);
var
  bi   : BITMAPINFO;
  bmp  : HBITMAP;
  DC   : HDC;
  p    : Pointer;
  w, h : Integer;
begin
//   
  DC := CreateCompatibleDC(GetDC(0));
  pPicture.get_Width(W);
  pPicture.get_Height(H);
  Width  := MulDiv(W, GetDeviceCaps(DC, LOGPIXELSX), 2540);
  Height := MulDiv(H, GetDeviceCaps(DC, LOGPIXELSY), 2540);
  BPP    := 24;
  ZeroMemory(@bi, SizeOf(bi));
  bi.bmiHeader.biSize        := SizeOf(BITMAPINFOHEADER);
  bi.bmiHeader.biBitCount    := 24;
  bi.bmiHeader.biWidth       := Width;
  bi.bmiHeader.biHeight      := Height;
  bi.bmiHeader.biCompression := BI_RGB;
  bi.bmiHeader.biPlanes      := 1;
  bmp := CreateDIBSection(DC, bi, DIB_RGB_COLORS, p, 0, 0);
  SelectObject(DC, bmp);
  pPicture.Render(DC, 0, 0, Width, Height, 0, H, W, -H, nil);
  GetMem(Data, Width * Height * 3);
  GetBitmapBits(bmp, Width * Height * 3, Data);
  DeleteObject(bmp);
  DeleteDC(DC);
end;

//   
function LoadBJG(const FileName: PChar; var Width, Height, BPP: Integer; var Data: PByteArray): Boolean;
var
  v         : TVarData;
  pPicture  : IPicture;
  pDispatch : IDispatch;
begin
//        "oleaut32.dll"
  Result := False;

  //   
    ZeroMemory(@v, SizeOf(v));
    v.VType     := varOleStr;
    v.varOleStr := StringToOleStr(FileName);
    if OleLoadPictureFile(v, pDispatch) = 0 then
    begin
    //  HBITMAP
      pDispatch.QueryInterface(IID_IPicture, pPicture);
      CreateBitmap(pPicture, Width, Height, BPP, Data);
      Result := True;
    end;
end;      

function Load1(FileName: PChar; var W, H, BPP: Integer; var Data: Pointer): Boolean;
begin
 Result := LoadBJG(FileName, W, H, BPP, PByteArray(Data));
end;


function NewID(const Name: string; Data: Pointer; c, f, W, H: Integer; Clamp, MipMap: Boolean): LongWord;
var ID:longword;
begin
    glGenTextures(1, @ID);
    glBindTexture(GL_TEXTURE_2D, ID);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

    if clamp then
    begin
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    end else
    begin
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    end;

    if MipMap then
      glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR)
    else
      glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    glTexParameterf(GL_TEXTURE_2D, GENERATE_MIPMAP_SGIS, Byte(MipMap));
    glTexImage2D(GL_TEXTURE_2D, 0, c, W, H, 0, f, GL_UNSIGNED_BYTE, Data);
    glTexParameterf(GL_TEXTURE_2D, GENERATE_MIPMAP_SGIS, 0);

    Result := ID;
end;

procedure Free(var Data: Pointer);
begin
    if Data <> nil then
      FreeMem(Data);
    Data := nil;
end;



function Load(FileName: PChar; Clamp, MipMap: Boolean):  LongWord;
var
  idx     : Integer;
  W, H, b : Integer;
  Data    : Pointer;
  c, f    : Integer;
begin
  Result := 0;
  if FileName = '' then
    Exit;
  Result := 0;
    //     - 
    if not Load1(FileName, W, H, b, Data) then
      Exit;

    //      8, 24  32 
    case b of
      8  : begin
             c := GL_LUMINANCE8;
             f := GL_LUMINANCE;
           end;
      24 : begin
             c := GL_RGB8;
             f := GL_BGR;
           end
    else
      c := GL_RGBA8;
      f := GL_BGRA;
    end;

    Result := NewID(FileName, Data, c, f, W, H, Clamp, MipMap);
    Free(Data);

end;


end.
